diff --git a/doc/src/sgml/pgtrgm.sgml b/doc/src/sgml/pgtrgm.sgml
index 07bfcac9319..fce868d47d6 100644
--- a/doc/src/sgml/pgtrgm.sgml
+++ b/doc/src/sgml/pgtrgm.sgml
@@ -22,7 +22,7 @@
   on the current database.
  </para>
 
- <sect2 id="pgtrgm-concepts">
+ <sect2 id="pgtrgm-concepts" xreflabel="Trigram (or Trigraph) Concepts">
   <title>Trigram (or Trigraph) Concepts</title>
 
   <para>
@@ -60,7 +60,7 @@
   </note>
  </sect2>
 
- <sect2 id="pgtrgm-funcs-ops">
+ <sect2 id="pgtrgm-funcs-ops" xreflabel="Functions and Operators">
   <title>Functions and Operators</title>
 
   <para>
@@ -356,7 +356,7 @@
   </table>
  </sect2>
 
- <sect2 id="pgtrgm-guc">
+ <sect2 id="pgtrgm-guc" xreflabel="GUC Parameters">
   <title>GUC Parameters</title>
 
   <variablelist>
@@ -407,7 +407,7 @@
   </variablelist>
  </sect2>
 
- <sect2 id="pgtrgm-index">
+ <sect2 id="pgtrgm-index" xreflabel="Index Support">
   <title>Index Support</title>
 
   <para>
@@ -560,7 +560,7 @@ SELECT * FROM test_trgm WHERE t ~ '(foo|bar)';
   </para>
  </sect2>
 
- <sect2 id="pgtrgm-text-search">
+ <sect2 id="pgtrgm-text-search" xreflabel="Text Search Integration">
   <title>Text Search Integration</title>
 
   <para>
@@ -609,7 +609,7 @@ CREATE INDEX words_idx ON words USING GIN (word gin_trgm_ops);
   </note>
  </sect2>
 
- <sect2 id="pgtrgm-references">
+ <sect2 id="pgtrgm-references" xreflabel="References">
   <title>References</title>
 
   <para>
@@ -622,7 +622,7 @@ CREATE INDEX words_idx ON words USING GIN (word gin_trgm_ops);
   </para>
  </sect2>
 
- <sect2 id="pgtrgm-authors">
+ <sect2 id="pgtrgm-authors" xreflabel="Authors">
   <title>Authors</title>
 
   <para>
diff --git a/doc/src/sgml/pgvisibility.sgml b/doc/src/sgml/pgvisibility.sgml
index 097f7e05661..1a2a37026b3 100644
--- a/doc/src/sgml/pgvisibility.sgml
+++ b/doc/src/sgml/pgvisibility.sgml
@@ -41,7 +41,7 @@
   data blocks are similarly expensive.
  </para>
 
- <sect2 id="pgvisibility-funcs">
+ <sect2 id="pgvisibility-funcs" xreflabel="Functions">
   <title>Functions</title>
 
   <variablelist>
@@ -147,7 +147,7 @@
   </para>
  </sect2>
 
- <sect2 id="pgvisibility-author">
+ <sect2 id="pgvisibility-author" xreflabel="Author">
   <title>Author</title>
 
   <para>
diff --git a/doc/src/sgml/pgwalinspect.sgml b/doc/src/sgml/pgwalinspect.sgml
index 79c3ead40bc..851c20a9c47 100644
--- a/doc/src/sgml/pgwalinspect.sgml
+++ b/doc/src/sgml/pgwalinspect.sgml
@@ -56,7 +56,7 @@
   superusers to others using <command>GRANT</command>.
  </para>
 
- <sect2 id="pgwalinspect-funcs">
+ <sect2 id="pgwalinspect-funcs" xreflabel="General Functions">
   <title>General Functions</title>
 
   <variablelist>
@@ -275,7 +275,7 @@ combined_size_percentage     | 2.8634072910530795
   </variablelist>
  </sect2>
 
- <sect2 id="pgwalinspect-author">
+ <sect2 id="pgwalinspect-author" xreflabel="Author">
   <title>Author</title>
 
   <para>
diff --git a/doc/src/sgml/planstats.sgml b/doc/src/sgml/planstats.sgml
index e57867ba617..045b8df441f 100644
--- a/doc/src/sgml/planstats.sgml
+++ b/doc/src/sgml/planstats.sgml
@@ -19,7 +19,7 @@
    wishes to read the code.
   </para>
 
- <sect1 id="row-estimation-examples">
+ <sect1 id="row-estimation-examples" xreflabel="Row Estimation Examples">
   <title>Row Estimation Examples</title>
 
   <indexterm zone="row-estimation-examples">
@@ -447,7 +447,7 @@ rows = (outer_cardinality * inner_cardinality) * selectivity
   </para>
  </sect1>
 
- <sect1 id="multivariate-statistics-examples">
+ <sect1 id="multivariate-statistics-examples" xreflabel="Multivariate Statistics Examples">
   <title>Multivariate Statistics Examples</title>
 
   <indexterm>
@@ -455,7 +455,7 @@ rows = (outer_cardinality * inner_cardinality) * selectivity
    <secondary>multivariate</secondary>
   </indexterm>
 
-  <sect2 id="functional-dependencies">
+  <sect2 id="functional-dependencies" xreflabel="Functional Dependencies">
    <title>Functional Dependencies</title>
 
    <para>
@@ -540,7 +540,7 @@ EXPLAIN (ANALYZE, TIMING OFF, BUFFERS OFF) SELECT * FROM t WHERE a = 1 AND b = 1
    </para>
   </sect2>
 
-  <sect2 id="multivariate-ndistinct-counts">
+  <sect2 id="multivariate-ndistinct-counts" xreflabel="Multivariate N-Distinct Counts">
    <title>Multivariate N-Distinct Counts</title>
 
    <para>
@@ -586,7 +586,7 @@ EXPLAIN (ANALYZE, TIMING OFF, BUFFERS OFF) SELECT COUNT(*) FROM t GROUP BY a, b;
 
   </sect2>
 
-  <sect2 id="mcv-lists">
+  <sect2 id="mcv-lists" xreflabel="MCV Lists">
    <title>MCV Lists</title>
 
    <para>
@@ -699,7 +699,7 @@ EXPLAIN (ANALYZE, TIMING OFF, BUFFERS OFF) SELECT * FROM t WHERE a &lt;= 49 AND
 
  </sect1>
 
- <sect1 id="planner-stats-security">
+ <sect1 id="planner-stats-security" xreflabel="Planner Statistics and Security">
   <title>Planner Statistics and Security</title>
 
   <para>
diff --git a/doc/src/sgml/plperl.sgml b/doc/src/sgml/plperl.sgml
index 6f018645f11..7e7881bf066 100644
--- a/doc/src/sgml/plperl.sgml
+++ b/doc/src/sgml/plperl.sgml
@@ -46,7 +46,7 @@
    </para>
   </note>
 
- <sect1 id="plperl-funcs">
+ <sect1 id="plperl-funcs" xreflabel="PL/Perl Functions and Arguments">
   <title>PL/Perl Functions and Arguments</title>
 
   <para>
@@ -407,7 +407,7 @@ use strict;
 
  </sect1>
 
- <sect1 id="plperl-data">
+ <sect1 id="plperl-data" xreflabel="Data Values in PL/Perl">
   <title>Data Values in PL/Perl</title>
 
   <para>
@@ -427,10 +427,10 @@ use strict;
   </para>
  </sect1>
 
- <sect1 id="plperl-builtins">
+ <sect1 id="plperl-builtins" xreflabel="Built-in Functions">
   <title>Built-in Functions</title>
 
- <sect2 id="plperl-database">
+ <sect2 id="plperl-database" xreflabel="Database Access from PL/Perl">
   <title>Database Access from PL/Perl</title>
 
   <para>
@@ -781,7 +781,7 @@ CALL transaction_test1();
    </variablelist>
  </sect2>
 
- <sect2 id="plperl-utility-functions">
+ <sect2 id="plperl-utility-functions" xreflabel="Utility Functions in PL/Perl">
   <title>Utility Functions in PL/Perl</title>
 
    <variablelist>
@@ -996,7 +996,7 @@ CALL transaction_test1();
   </sect2>
  </sect1>
 
- <sect1 id="plperl-global">
+ <sect1 id="plperl-global" xreflabel="Global Values in PL/Perl">
   <title>Global Values in PL/Perl</title>
 
   <para>
@@ -1071,7 +1071,7 @@ $$ LANGUAGE plperl;
   </para>
  </sect1>
 
- <sect1 id="plperl-trusted">
+ <sect1 id="plperl-trusted" xreflabel="Trusted and Untrusted PL/Perl">
   <title>Trusted and Untrusted PL/Perl</title>
 
   <indexterm zone="plperl-trusted">
@@ -1184,7 +1184,7 @@ $$ LANGUAGE plperl;
 
  </sect1>
 
- <sect1 id="plperl-triggers">
+ <sect1 id="plperl-triggers" xreflabel="PL/Perl Triggers">
   <title>PL/Perl Triggers</title>
 
   <para>
@@ -1372,7 +1372,7 @@ CREATE TRIGGER test_valid_id_trig
   </para>
  </sect1>
 
- <sect1 id="plperl-event-triggers">
+ <sect1 id="plperl-event-triggers" xreflabel="PL/Perl Event Triggers">
   <title>PL/Perl Event Triggers</title>
 
   <para>
@@ -1422,10 +1422,10 @@ CREATE EVENT TRIGGER perl_a_snitch
   </para>
  </sect1>
 
- <sect1 id="plperl-under-the-hood">
+ <sect1 id="plperl-under-the-hood" xreflabel="PL/Perl Under the Hood">
   <title>PL/Perl Under the Hood</title>
 
- <sect2 id="plperl-config">
+ <sect2 id="plperl-config" xreflabel="Configuration">
   <title>Configuration</title>
 
   <para>
@@ -1553,7 +1553,7 @@ DO 'elog(WARNING, join ", ", sort keys %INC)' LANGUAGE plperl;
   </variablelist>
 </sect2>
 
- <sect2 id="plperl-missing">
+ <sect2 id="plperl-missing" xreflabel="Limitations and Missing Features">
   <title>Limitations and Missing Features</title>
 
   <para>
diff --git a/doc/src/sgml/plpgsql.sgml b/doc/src/sgml/plpgsql.sgml
index 561f6e50d63..891299faa44 100644
--- a/doc/src/sgml/plpgsql.sgml
+++ b/doc/src/sgml/plpgsql.sgml
@@ -7,7 +7,7 @@
   <primary>PL/pgSQL</primary>
  </indexterm>
 
- <sect1 id="plpgsql-overview">
+ <sect1 id="plpgsql-overview" xreflabel="Overview">
   <title>Overview</title>
 
  <para>
@@ -65,7 +65,7 @@
     administrators could choose to remove it.
    </para>
 
-  <sect2 id="plpgsql-advantages">
+  <sect2 id="plpgsql-advantages" xreflabel="Advantages of Using PL/pgSQL">
    <title>Advantages of Using <application>PL/pgSQL</application></title>
 
     <para>
@@ -114,7 +114,7 @@
     </para>
   </sect2>
 
-  <sect2 id="plpgsql-args-results">
+  <sect2 id="plpgsql-args-results" xreflabel="Supported Argument and Result Data Types">
    <title>Supported Argument and Result Data Types</title>
 
     <para>
@@ -177,7 +177,7 @@
   </sect2>
  </sect1>
 
- <sect1 id="plpgsql-structure">
+ <sect1 id="plpgsql-structure" xreflabel="Structure of PL/pgSQL">
   <title>Structure of <application>PL/pgSQL</application></title>
 
   <para>
@@ -312,7 +312,7 @@ $$ LANGUAGE plpgsql;
     </para>
   </sect1>
 
-  <sect1 id="plpgsql-declarations">
+  <sect1 id="plpgsql-declarations" xreflabel="Declarations">
     <title>Declarations</title>
 
     <para>
@@ -393,7 +393,7 @@ DECLARE
 </programlisting>
      </para>
 
-    <sect2 id="plpgsql-declaration-parameters">
+    <sect2 id="plpgsql-declaration-parameters" xreflabel="Declaring Function Parameters">
      <title>Declaring Function Parameters</title>
 
      <para>
@@ -639,7 +639,7 @@ SELECT add_three_values(1, 2, 4.7);
      </para>
     </sect2>
 
-  <sect2 id="plpgsql-declaration-alias">
+  <sect2 id="plpgsql-declaration-alias" xreflabel="ALIAS">
    <title><literal>ALIAS</literal></title>
 
 <synopsis>
@@ -671,7 +671,7 @@ DECLARE
    </para>
    </sect2>
 
-  <sect2 id="plpgsql-declaration-type">
+  <sect2 id="plpgsql-declaration-type" xreflabel="Copying Types">
    <title>Copying Types</title>
 
 <synopsis>
@@ -726,7 +726,7 @@ user_ids users.user_id%TYPE ARRAY[4];  -- equivalent to the above
 
   </sect2>
 
-    <sect2 id="plpgsql-declaration-rowtypes">
+    <sect2 id="plpgsql-declaration-rowtypes" xreflabel="Row Types">
      <title>Row Types</title>
 
 <synopsis>
@@ -789,7 +789,7 @@ SELECT merge_fields(t.*) FROM table1 t WHERE ... ;
    </para>
   </sect2>
 
-  <sect2 id="plpgsql-declaration-records">
+  <sect2 id="plpgsql-declaration-records" xreflabel="Record Types">
    <title>Record Types</title>
 
 <synopsis>
@@ -819,7 +819,7 @@ SELECT merge_fields(t.*) FROM table1 t WHERE ... ;
    </para>
   </sect2>
 
-  <sect2 id="plpgsql-declaration-collation">
+  <sect2 id="plpgsql-declaration-collation" xreflabel="Collation of PL/pgSQL Variables">
    <title>Collation of <application>PL/pgSQL</application> Variables</title>
 
    <indexterm>
@@ -913,7 +913,7 @@ $$ LANGUAGE plpgsql;
   </sect2>
   </sect1>
 
-  <sect1 id="plpgsql-expressions">
+  <sect1 id="plpgsql-expressions" xreflabel="Expressions">
   <title>Expressions</title>
 
     <para>
@@ -974,7 +974,7 @@ IF count(*) &gt; 0 FROM my_table THEN ...
     </para>
   </sect1>
 
-  <sect1 id="plpgsql-statements">
+  <sect1 id="plpgsql-statements" xreflabel="Basic Statements">
   <title>Basic Statements</title>
 
    <para>
@@ -986,7 +986,7 @@ IF count(*) &gt; 0 FROM my_table THEN ...
     as described in <xref linkend="plpgsql-statements-general-sql"/>.
    </para>
 
-   <sect2 id="plpgsql-statements-assignment">
+   <sect2 id="plpgsql-statements-assignment" xreflabel="Assignment">
     <title>Assignment</title>
 
     <para>
@@ -1029,7 +1029,7 @@ complex_array[n].realpart = 12.3;
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-statements-general-sql">
+   <sect2 id="plpgsql-statements-general-sql" xreflabel="Executing SQL Commands">
     <title>Executing SQL Commands</title>
 
     <para>
@@ -1148,7 +1148,7 @@ PERFORM create_mv('cs_session_page_requests_mv', my_query);
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-statements-sql-onerow">
+   <sect2 id="plpgsql-statements-sql-onerow" xreflabel="Executing a Command with a Single-Row Result">
     <title>Executing a Command with a Single-Row Result</title>
 
     <indexterm zone="plpgsql-statements-sql-onerow">
@@ -1309,7 +1309,7 @@ CONTEXT:  PL/pgSQL function get_userid(text) line 6 at SQL statement
 
    </sect2>
 
-   <sect2 id="plpgsql-statements-executing-dyn">
+   <sect2 id="plpgsql-statements-executing-dyn" xreflabel="Executing Dynamic Commands">
     <title>Executing Dynamic Commands</title>
 
     <para>
@@ -1610,7 +1610,7 @@ EXECUTE format('UPDATE tbl SET %I = $1 WHERE key = $2', colname)
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-statements-diagnostics">
+   <sect2 id="plpgsql-statements-diagnostics" xreflabel="Obtaining the Result Status">
     <title>Obtaining the Result Status</title>
 
     <para>
@@ -1751,7 +1751,7 @@ GET DIAGNOSTICS integer_var = ROW_COUNT;
 
    </sect2>
 
-   <sect2 id="plpgsql-statements-null">
+   <sect2 id="plpgsql-statements-null" xreflabel="Doing Nothing At All">
     <title>Doing Nothing At All</title>
 
     <para>
@@ -1798,7 +1798,7 @@ END;
    </sect2>
   </sect1>
 
-  <sect1 id="plpgsql-control-structures">
+  <sect1 id="plpgsql-control-structures" xreflabel="Control Structures">
    <title>Control Structures</title>
 
    <para>
@@ -1809,7 +1809,7 @@ END;
     flexible and powerful way.
    </para>
 
-   <sect2 id="plpgsql-statements-returning">
+   <sect2 id="plpgsql-statements-returning" xreflabel="Returning from a Function">
     <title>Returning from a Function</title>
 
     <para>
@@ -1818,7 +1818,7 @@ END;
      NEXT</command>.
     </para>
 
-    <sect3 id="plpgsql-statements-returning-return">
+    <sect3 id="plpgsql-statements-returning-return" xreflabel="RETURN">
      <title><command>RETURN</command></title>
 
 <synopsis>
@@ -1879,7 +1879,7 @@ RETURN (1, 2, 'three'::text);  -- must cast columns to correct types
      </para>
     </sect3>
 
-    <sect3 id="plpgsql-statements-returning-return-next">
+    <sect3 id="plpgsql-statements-returning-return-next" xreflabel="RETURN NEXT and RETURN QUERY">
      <title><command>RETURN NEXT</command> and <command>RETURN QUERY</command></title>
     <indexterm>
      <primary>RETURN NEXT</primary>
@@ -2029,7 +2029,7 @@ SELECT * FROM get_available_flightid(CURRENT_DATE);
     </sect3>
    </sect2>
 
-   <sect2 id="plpgsql-statements-returning-procedure">
+   <sect2 id="plpgsql-statements-returning-procedure" xreflabel="Returning from a Procedure">
     <title>Returning from a Procedure</title>
 
     <para>
@@ -2045,7 +2045,7 @@ SELECT * FROM get_available_flightid(CURRENT_DATE);
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-statements-calling-procedure">
+   <sect2 id="plpgsql-statements-calling-procedure" xreflabel="Calling a Procedure">
     <title>Calling a Procedure</title>
 
     <para>
@@ -2081,7 +2081,7 @@ $$;
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-conditionals">
+   <sect2 id="plpgsql-conditionals" xreflabel="Conditionals">
     <title>Conditionals</title>
 
     <para>
@@ -2111,7 +2111,7 @@ $$;
     </itemizedlist>
     </para>
 
-    <sect3 id="plpgsql-conditionals-if-then">
+    <sect3 id="plpgsql-conditionals-if-then" xreflabel="IF-THEN">
      <title><literal>IF-THEN</literal></title>
 
 <synopsis>
@@ -2138,7 +2138,7 @@ END IF;
        </para>
      </sect3>
 
-     <sect3 id="plpgsql-conditionals-if-then-else">
+     <sect3 id="plpgsql-conditionals-if-then-else" xreflabel="IF-THEN-ELSE">
       <title><literal>IF-THEN-ELSE</literal></title>
 
 <synopsis>
@@ -2179,7 +2179,7 @@ END IF;
      </para>
     </sect3>
 
-     <sect3 id="plpgsql-conditionals-if-then-elsif">
+     <sect3 id="plpgsql-conditionals-if-then-elsif" xreflabel="IF-THEN-ELSIF">
       <title><literal>IF-THEN-ELSIF</literal></title>
 
 <synopsis>
@@ -2255,7 +2255,7 @@ END IF;
        </para>
      </sect3>
 
-     <sect3 id="plpgsql-conditionals-simple-case">
+     <sect3 id="plpgsql-conditionals-simple-case" xreflabel="Simple CASE">
       <title>Simple <literal>CASE</literal></title>
 
 <synopsis>
@@ -2298,7 +2298,7 @@ END CASE;
       </para>
      </sect3>
 
-     <sect3 id="plpgsql-conditionals-searched-case">
+     <sect3 id="plpgsql-conditionals-searched-case" xreflabel="Searched CASE">
       <title>Searched <literal>CASE</literal></title>
 
 <synopsis>
@@ -2350,7 +2350,7 @@ END CASE;
      </sect3>
    </sect2>
 
-   <sect2 id="plpgsql-control-structures-loops">
+   <sect2 id="plpgsql-control-structures-loops" xreflabel="Simple Loops">
     <title>Simple Loops</title>
 
     <indexterm zone="plpgsql-control-structures-loops">
@@ -2365,7 +2365,7 @@ END CASE;
      <application>PL/pgSQL</application> function to repeat a series of commands.
     </para>
 
-    <sect3 id="plpgsql-control-structures-loops-loop">
+    <sect3 id="plpgsql-control-structures-loops-loop" xreflabel="LOOP">
      <title><literal>LOOP</literal></title>
 
 <synopsis>
@@ -2385,7 +2385,7 @@ END LOOP <optional> <replaceable>label</replaceable> </optional>;
      </para>
     </sect3>
 
-     <sect3 id="plpgsql-control-structures-loops-exit">
+     <sect3 id="plpgsql-control-structures-loops-exit" xreflabel="EXIT">
       <title><literal>EXIT</literal></title>
 
      <indexterm>
@@ -2457,7 +2457,7 @@ END;
        </para>
      </sect3>
 
-     <sect3 id="plpgsql-control-structures-loops-continue">
+     <sect3 id="plpgsql-control-structures-loops-continue" xreflabel="CONTINUE">
       <title><literal>CONTINUE</literal></title>
 
      <indexterm>
@@ -2506,7 +2506,7 @@ END LOOP;
      </sect3>
 
 
-     <sect3 id="plpgsql-control-structures-loops-while">
+     <sect3 id="plpgsql-control-structures-loops-while" xreflabel="WHILE">
       <title><literal>WHILE</literal></title>
 
      <indexterm>
@@ -2543,7 +2543,7 @@ END LOOP;
        </para>
      </sect3>
 
-     <sect3 id="plpgsql-integer-for">
+     <sect3 id="plpgsql-integer-for" xreflabel="FOR (Integer Variant)">
       <title><literal>FOR</literal> (Integer Variant)</title>
 
 <synopsis>
@@ -2600,7 +2600,7 @@ END LOOP;
      </sect3>
    </sect2>
 
-   <sect2 id="plpgsql-records-iterating">
+   <sect2 id="plpgsql-records-iterating" xreflabel="Looping through Query Results">
     <title>Looping through Query Results</title>
 
     <para>
@@ -2696,7 +2696,7 @@ END LOOP <optional> <replaceable>label</replaceable> </optional>;
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-foreach-array">
+   <sect2 id="plpgsql-foreach-array" xreflabel="Looping through Arrays">
     <title>Looping through Arrays</title>
 
     <para>
@@ -2780,7 +2780,7 @@ NOTICE:  row = {10,11,12}
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-error-trapping">
+   <sect2 id="plpgsql-error-trapping" xreflabel="Trapping Errors">
     <title>Trapping Errors</title>
 
     <indexterm>
@@ -2943,7 +2943,7 @@ SELECT merge_db(1, 'dennis');
     </para>
     </example>
 
-   <sect3 id="plpgsql-exception-diagnostics">
+   <sect3 id="plpgsql-exception-diagnostics" xreflabel="Obtaining Information about an Error">
     <title>Obtaining Information about an Error</title>
 
     <para>
@@ -3072,7 +3072,7 @@ END;
    </sect3>
   </sect2>
 
-  <sect2 id="plpgsql-call-stack">
+  <sect2 id="plpgsql-call-stack" xreflabel="Obtaining Execution Location Information">
    <title>Obtaining Execution Location Information</title>
 
    <para>
@@ -3127,7 +3127,7 @@ CONTEXT:  PL/pgSQL function outer_func() line 3 at RETURN
   </sect2>
   </sect1>
 
-  <sect1 id="plpgsql-cursors">
+  <sect1 id="plpgsql-cursors" xreflabel="Cursors">
    <title>Cursors</title>
 
    <indexterm zone="plpgsql-cursors">
@@ -3148,7 +3148,7 @@ CONTEXT:  PL/pgSQL function outer_func() line 3 at RETURN
     large row sets from functions.
    </para>
 
-   <sect2 id="plpgsql-cursor-declarations">
+   <sect2 id="plpgsql-cursor-declarations" xreflabel="Declaring Cursor Variables">
     <title>Declaring Cursor Variables</title>
 
     <para>
@@ -3202,7 +3202,7 @@ DECLARE
     </para>
    </sect2>
 
-   <sect2 id="plpgsql-cursor-opening">
+   <sect2 id="plpgsql-cursor-opening" xreflabel="Opening Cursors">
     <title>Opening Cursors</title>
 
     <para>
@@ -3242,7 +3242,7 @@ DECLARE
      <xref linkend="plpgsql-cursor-returning"/>.
     </para>
 
-    <sect3 id="plpgsql-cursor-opening-open-for-query">
+    <sect3 id="plpgsql-cursor-opening-open-for-query" xreflabel="OPEN FOR query">
      <title><command>OPEN FOR</command> <replaceable>query</replaceable></title>
 
 <synopsis>
@@ -3276,7 +3276,7 @@ OPEN curs1 FOR SELECT * FROM foo WHERE key = mykey;
        </para>
      </sect3>
 
-    <sect3 id="plpgsql-cursor-opening-open-for-execute">
+    <sect3 id="plpgsql-cursor-opening-open-for-execute" xreflabel="OPEN FOR EXECUTE">
      <title><command>OPEN FOR EXECUTE</command></title>
 
 <synopsis>
@@ -3313,7 +3313,7 @@ OPEN curs1 FOR EXECUTE format('SELECT * FROM %I WHERE col1 = $1',tabname) USING
        </para>
      </sect3>
 
-    <sect3 id="plpgsql-open-bound-cursor">
+    <sect3 id="plpgsql-open-bound-cursor" xreflabel="Opening a Bound Cursor">
      <title>Opening a Bound Cursor</title>
 
 <synopsis>
@@ -3379,7 +3379,7 @@ BEGIN
      </sect3>
    </sect2>
 
-   <sect2 id="plpgsql-cursor-using">
+   <sect2 id="plpgsql-cursor-using" xreflabel="Using Cursors">
     <title>Using Cursors</title>
 
     <para>
@@ -3403,7 +3403,7 @@ BEGIN
      only until the end of the transaction.
     </para>
 
-    <sect3 id="plpgsql-cursor-using-fetch">
+    <sect3 id="plpgsql-cursor-using-fetch" xreflabel="FETCH">
      <title><literal>FETCH</literal></title>
 
 <synopsis>
@@ -3463,7 +3463,7 @@ FETCH RELATIVE -2 FROM curs4 INTO x;
        </para>
      </sect3>
 
-    <sect3 id="plpgsql-cursor-using-move">
+    <sect3 id="plpgsql-cursor-using-move" xreflabel="MOVE">
      <title><literal>MOVE</literal></title>
 
 <synopsis>
@@ -3504,7 +3504,7 @@ MOVE FORWARD 2 FROM curs4;
        </para>
      </sect3>
 
-    <sect3 id="plpgsql-cursor-using-update-delete">
+    <sect3 id="plpgsql-cursor-using-update-delete" xreflabel="UPDATE/DELETE WHERE CURRENT OF">
      <title><literal>UPDATE/DELETE WHERE CURRENT OF</literal></title>
 
 <synopsis>
@@ -3530,7 +3530,7 @@ UPDATE foo SET dataval = myval WHERE CURRENT OF curs1;
        </para>
      </sect3>
 
-    <sect3 id="plpgsql-cursor-using-close">
+    <sect3 id="plpgsql-cursor-using-close" xreflabel="CLOSE">
      <title><literal>CLOSE</literal></title>
 
 <synopsis>
@@ -3551,7 +3551,7 @@ CLOSE curs1;
        </para>
      </sect3>
 
-    <sect3 id="plpgsql-cursor-returning">
+    <sect3 id="plpgsql-cursor-returning" xreflabel="Returning Cursors">
      <title>Returning Cursors</title>
 
        <para>
@@ -3665,7 +3665,7 @@ COMMIT;
      </sect3>
    </sect2>
 
-   <sect2 id="plpgsql-cursor-for-loop">
+   <sect2 id="plpgsql-cursor-for-loop" xreflabel="Looping through a Cursor's Result">
     <title>Looping through a Cursor's Result</title>
 
     <para>
@@ -3700,7 +3700,7 @@ END LOOP <optional> <replaceable>label</replaceable> </optional>;
 
   </sect1>
 
-  <sect1 id="plpgsql-transactions">
+  <sect1 id="plpgsql-transactions" xreflabel="Transaction Management">
    <title>Transaction Management</title>
 
    <para>
@@ -3813,10 +3813,10 @@ CALL transaction_test2();
    </para>
   </sect1>
 
-  <sect1 id="plpgsql-errors-and-messages">
+  <sect1 id="plpgsql-errors-and-messages" xreflabel="Errors and Messages">
    <title>Errors and Messages</title>
 
-  <sect2 id="plpgsql-statements-raise">
+  <sect2 id="plpgsql-statements-raise" xreflabel="Reporting Errors and Messages">
    <title>Reporting Errors and Messages</title>
 
    <indexterm>
@@ -4027,7 +4027,7 @@ RAISE unique_violation USING MESSAGE = 'Duplicate user ID: ' || user_id;
 
   </sect2>
 
-  <sect2 id="plpgsql-statements-assert">
+  <sect2 id="plpgsql-statements-assert" xreflabel="Checking Assertions">
    <title>Checking Assertions</title>
 
    <indexterm>
@@ -4088,7 +4088,7 @@ ASSERT <replaceable class="parameter">condition</replaceable> <optional> , <repl
 
  </sect1>
 
- <sect1 id="plpgsql-trigger">
+ <sect1 id="plpgsql-trigger" xreflabel="Trigger Functions">
   <title>Trigger Functions</title>
 
   <indexterm zone="plpgsql-trigger">
@@ -4107,7 +4107,7 @@ ASSERT <replaceable class="parameter">condition</replaceable> <optional> , <repl
    automatically defined to describe the condition that triggered the call.
   </para>
 
-  <sect2 id="plpgsql-dml-trigger">
+  <sect2 id="plpgsql-dml-trigger" xreflabel="Triggers on Data Changes">
    <title>Triggers on Data Changes</title>
 
   <para>
@@ -4723,7 +4723,7 @@ CREATE TRIGGER emp_audit_del
 
 </sect2>
 
-  <sect2 id="plpgsql-event-trigger">
+  <sect2 id="plpgsql-event-trigger" xreflabel="Triggers on Events">
    <title>Triggers on Events</title>
 
    <para>
@@ -4787,7 +4787,7 @@ CREATE EVENT TRIGGER snitch ON ddl_command_start EXECUTE FUNCTION snitch();
 
   </sect1>
 
-  <sect1 id="plpgsql-implementation">
+  <sect1 id="plpgsql-implementation" xreflabel="PL/pgSQL under the Hood">
    <title><application>PL/pgSQL</application> under the Hood</title>
 
    <para>
@@ -4795,7 +4795,7 @@ CREATE EVENT TRIGGER snitch ON ddl_command_start EXECUTE FUNCTION snitch();
     frequently important for <application>PL/pgSQL</application> users to know.
    </para>
 
-  <sect2 id="plpgsql-var-subst">
+  <sect2 id="plpgsql-var-subst" xreflabel="Variable Substitution">
    <title>Variable Substitution</title>
 
    <para>
@@ -4973,7 +4973,7 @@ $$ LANGUAGE plpgsql;
 
   </sect2>
 
-  <sect2 id="plpgsql-plan-caching">
+  <sect2 id="plpgsql-plan-caching" xreflabel="Plan Caching">
    <title>Plan Caching</title>
 
    <para>
@@ -5128,7 +5128,7 @@ $$ LANGUAGE plpgsql;
 
   </sect1>
 
- <sect1 id="plpgsql-development-tips">
+ <sect1 id="plpgsql-development-tips" xreflabel="Tips for Developing in PL/pgSQL">
   <title>Tips for Developing in <application>PL/pgSQL</application></title>
 
    <para>
@@ -5165,7 +5165,7 @@ $$ LANGUAGE plpgsql;
     making it easier to recreate and debug functions.
    </para>
 
-  <sect2 id="plpgsql-quote-tips">
+  <sect2 id="plpgsql-quote-tips" xreflabel="Handling of Quotation Marks">
    <title>Handling of Quotation Marks</title>
 
    <para>
@@ -5321,7 +5321,7 @@ a_output := a_output || $$ IF v_$$ || referrer_keys.kind || $$ LIKE '$$
   </variablelist>
 
   </sect2>
-  <sect2 id="plpgsql-extra-checks">
+  <sect2 id="plpgsql-extra-checks" xreflabel="Additional Compile-Time and Run-Time Checks">
    <title>Additional Compile-Time and Run-Time Checks</title>
 
    <para>
@@ -5446,7 +5446,7 @@ HINT:  Make sure the query returns the exact list of columns.
 
   <!-- **** Porting from Oracle PL/SQL **** -->
 
- <sect1 id="plpgsql-porting">
+ <sect1 id="plpgsql-porting" xreflabel="Porting from Oracle PL/SQL">
   <title>Porting from <productname>Oracle</productname> PL/SQL</title>
 
   <indexterm zone="plpgsql-porting">
@@ -5560,7 +5560,7 @@ HINT:  Make sure the query returns the exact list of columns.
     </itemizedlist>
    </para>
 
-  <sect2 id="plpgsql-porting-examples">
+  <sect2 id="plpgsql-porting-examples" xreflabel="Porting Examples">
    <title>Porting Examples</title>
 
    <para>
@@ -5955,7 +5955,7 @@ $$ LANGUAGE plpgsql;
    </example>
   </sect2>
 
-  <sect2 id="plpgsql-porting-other">
+  <sect2 id="plpgsql-porting-other" xreflabel="Other Things to Watch For">
    <title>Other Things to Watch For</title>
 
    <para>
@@ -5964,7 +5964,7 @@ $$ LANGUAGE plpgsql;
     <productname>PostgreSQL</productname>.
    </para>
 
-   <sect3 id="plpgsql-porting-exceptions">
+   <sect3 id="plpgsql-porting-exceptions" xreflabel="Implicit Rollback after Exceptions">
     <title>Implicit Rollback after Exceptions</title>
 
     <para>
@@ -5996,7 +5996,7 @@ END;
     </para>
    </sect3>
 
-   <sect3 id="plpgsql-porting-other-execute">
+   <sect3 id="plpgsql-porting-other-execute" xreflabel="EXECUTE">
     <title><command>EXECUTE</command></title>
 
     <para>
@@ -6011,7 +6011,7 @@ END;
     </para>
    </sect3>
 
-   <sect3 id="plpgsql-porting-optimization">
+   <sect3 id="plpgsql-porting-optimization" xreflabel="Optimizing PL/pgSQL Functions">
     <title>Optimizing <application>PL/pgSQL</application> Functions</title>
 
     <para>
@@ -6038,7 +6038,7 @@ $$ LANGUAGE plpgsql STRICT IMMUTABLE;
    </sect3>
   </sect2>
 
-  <sect2 id="plpgsql-porting-appendix">
+  <sect2 id="plpgsql-porting-appendix" xreflabel="Appendix">
    <title>Appendix</title>
 
    <para>
